//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4180117A019B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4180117A019B.cm

//## begin module%4180117A019B.cp preserve=no
//## end module%4180117A019B.cp

//## Module: Chain%4180117A019B; Package specification
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/Chain.h

#ifndef CHAIN_H
#define CHAIN_H 1

//## begin module%4180117A019B.additionalIncludes preserve=no
//## end module%4180117A019B.additionalIncludes

//## begin module%4180117A019B.includes preserve=yes
//## end module%4180117A019B.includes

// Error
#include <XSUtil/Error/Error.h>

class ChainIO;

//## begin module%4180117A019B.declarations preserve=no
//## end module%4180117A019B.declarations

//## begin module%4180117A019B.additionalDeclarations preserve=yes
#include <xsTypes.h>
//## end module%4180117A019B.additionalDeclarations


//## begin Chain%4180176A01EC.preface preserve=yes
//## end Chain%4180176A01EC.preface

//## Class: Chain%4180176A01EC
//## Category: XSFit::MCMC%41E6AB1C02FC
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class Chain 
{
  //## begin Chain%4180176A01EC.initialDeclarations preserve=yes
  //## end Chain%4180176A01EC.initialDeclarations

  public:
    //## Class: ChainError%41813D1F0280
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ChainError : public YellowAlert  //## Inherits: <unnamed>%41813D4103C5
    {
      public:
        //## Constructors (specified)
          //## Operation: ChainError%41813DFD0219
          ChainError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Class: ParamID%41EFE7EC02EE
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct ParamID 
    {
        //## Equality Operations (generated)
          int operator==(const ParamID &right) const;

          int operator!=(const ParamID &right) const;

        // Data Members for Class Attributes

          //## Attribute: modName%41EFE8330113
          //## begin Chain::ParamID::modName%41EFE8330113.attr preserve=no  public: string {U} 
          string modName;
          //## end Chain::ParamID::modName%41EFE8330113.attr

          //## Attribute: parName%41EFE852011B
          //## begin Chain::ParamID::parName%41EFE852011B.attr preserve=no  public: string {U} 
          string parName;
          //## end Chain::ParamID::parName%41EFE852011B.attr

          //## Attribute: index%41EFE8710121
          //## begin Chain::ParamID::index%41EFE8710121.attr preserve=no  public: size_t {U} 
          size_t index;
          //## end Chain::ParamID::index%41EFE8710121.attr

          //## Attribute: units%41F7B4DB03CF
          //## begin Chain::ParamID::units%41F7B4DB03CF.attr preserve=no  public: string {U} 
          string units;
          //## end Chain::ParamID::units%41F7B4DB03CF.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: ChainInterrupt%460140B402B4
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ChainInterrupt : public YellowAlert  //## Inherits: <unnamed>%460140E001CB
    {
      public:
        //## Constructors (specified)
          //## Operation: ChainInterrupt%4601442C00EA
          ChainInterrupt ();

      protected:
      private:
      private: //## implementation
    };

    //## Class: TemperInfoContainer%46D2F9B7032F
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::vector<std::pair<size_t,Real> > TemperInfoContainer;

    //## Constructors (specified)
      //## Operation: Chain%41811665000F
      Chain (ChainIO* pIO, const string& fileName, size_t burnLength, size_t length, bool rand);

      //## Operation: Chain%41824C1F0153
      Chain (ChainIO* pIO, const string& fileName);

    //## Destructor (generated)
      ~Chain();


    //## Other Operations (specified)
      //## Operation: getFileName%4181191D03DC
      const string& getFileName () const;

      //## Operation: run%418119F4027E
      void run (const size_t appendLength, const Real temperature);

      //## Operation: openForReadPoints%4194E2DD0211
      //	This is needed to initialize a sequence of readPoint
      //	calls.
      void openForReadPoints () const;

      //## Operation: closeFile%4194E31601FF
      void closeFile () const;

      //## Operation: readPoint%4194E37B03B3
      //	This is intended to be called repeatedly to step through
      //	the chain sequentially, similar to an iterator.  Before
      //	calling this to start a sequence, FIRST CALL openForRead
      //	Points to initialize things and set the IO marker at the
      //	first point in the chain.
      void readPoint (std::vector<Real>& chainVals) const;

      //## Operation: calcStats%4198DB3602EE
      void calcStats (size_t iPar, Real& mean, Real& variance, size_t& nRepeats);

      //## Operation: findParsInChain%41F155CD01E6
      void findParsInChain (std::vector<Chain::ParamID>& parIDs, std::vector<size_t>& found) const;

      //## Operation: findParsInChain%4213A31302E8
      std::vector<Chain::ParamID> findParsInChain (size_t par1, const string& modName1, size_t par2, const string& modName2) const;

      //## Operation: FWIDTH%461BE25B029F
      static int FWIDTH ();

      //## Operation: readPointFromLine%461D09C00141
      //	This differs from the similar readPoint function in a
      //	couple of ways:  It will return the par values at a
      //	specified line number as measured from the start of the
      //	first par value line, whereas readPoint simply grabs
      //	from the current position.  Also it fills a valarray
      //	(which it ASSUMES is properly sized already) rather than
      //	a vector, and doesn't include the fit statistic value.
      //	This is to interface more easily with the random point
      //	retrieval required in certain error simulations.
      void readPointFromLine (size_t lineNum, RealArray& parVals) const;

      //## Operation: TEMPERPREC%46D582B901C5
      static int TEMPERPREC ();

      //## Operation: format%46E848F203DE
      const string& format () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: burnLength%4181171F0022
      size_t burnLength () const;

      //## Attribute: length%4181174C003E
      size_t length () const;
      void length (size_t value);

      //## Attribute: rand%418117CE01A2
      bool rand () const;

      //## Attribute: width%4182AD900241
      size_t width () const;
      void width (size_t value);

      //## Attribute: paramIDs%41EE862501DE
      const std::vector<Chain::ParamID>& paramIDs () const;
      void paramIDs (const std::vector<Chain::ParamID>& value);

      //## Attribute: statistic%4214D2760151
      const string& statistic () const;
      void statistic (const string& value);

      //## Attribute: tempering%46D2FA68013F
      const Chain::TemperInfoContainer& tempering () const;
      void tempering (const Chain::TemperInfoContainer& value);

  public:
    // Additional Public Declarations
      //## begin Chain%4180176A01EC.public preserve=yes
      //## end Chain%4180176A01EC.public

  protected:
    // Additional Protected Declarations
      //## begin Chain%4180176A01EC.protected preserve=yes
      //## end Chain%4180176A01EC.protected

  private:
    //## Constructors (generated)
      Chain(const Chain &right);

    //## Assignment Operation (generated)
      Chain & operator=(const Chain &right);


    //## Other Operations (specified)
      //## Operation: cleanupRun%4190EC2501B1
      void cleanupRun (const std::vector<Real>& origPars);

      //## Operation: calcVar%4198DC5C004B
      Real calcVar (RealArray& parVals, Real mean) const;

      //## Operation: checkForRepeat%46114DAC02A6
      static bool checkForRepeat (const std::vector<Real>& prevPoint, const std::vector<Real>& point);

    // Additional Private Declarations
      //## begin Chain%4180176A01EC.private preserve=yes
      //## end Chain%4180176A01EC.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: fileName%418116890304
      //## begin Chain::fileName%418116890304.attr preserve=no  public: const string {U} 
      const string m_fileName;
      //## end Chain::fileName%418116890304.attr

      //## begin Chain::burnLength%4181171F0022.attr preserve=no  public: size_t {U} 
      size_t m_burnLength;
      //## end Chain::burnLength%4181171F0022.attr

      //## begin Chain::length%4181174C003E.attr preserve=no  public: size_t {U} 
      size_t m_length;
      //## end Chain::length%4181174C003E.attr

      //## begin Chain::rand%418117CE01A2.attr preserve=no  public: bool {U} 
      bool m_rand;
      //## end Chain::rand%418117CE01A2.attr

      //## begin Chain::width%4182AD900241.attr preserve=no  public: size_t {U} 
      size_t m_width;
      //## end Chain::width%4182AD900241.attr

      //## begin Chain::paramIDs%41EE862501DE.attr preserve=no  public: std::vector<Chain::ParamID> {U} 
      std::vector<Chain::ParamID> m_paramIDs;
      //## end Chain::paramIDs%41EE862501DE.attr

      //## begin Chain::statistic%4214D2760151.attr preserve=no  public: string {U} 
      string m_statistic;
      //## end Chain::statistic%4214D2760151.attr

      //## begin Chain::tempering%46D2FA68013F.attr preserve=no  public: Chain::TemperInfoContainer {U} 
      Chain::TemperInfoContainer m_tempering;
      //## end Chain::tempering%46D2FA68013F.attr

    // Data Members for Associations

      //## Association: XSFit::MCMC::<unnamed>%46DF0DA100D9
      //## Role: Chain::IO%46DF0DA203B5
      //	Opaque pointer to class performing Chain IO functions in
      //	a mixture of Strategy and Template patterns.
      //## begin Chain::IO%46DF0DA203B5.role preserve=no  private: ChainIO { -> 1RFHgN}
      ChainIO* m_IO;
      //## end Chain::IO%46DF0DA203B5.role

    // Additional Implementation Declarations
      //## begin Chain%4180176A01EC.implementation preserve=yes
      //## end Chain%4180176A01EC.implementation

};

//## begin Chain%4180176A01EC.postscript preserve=yes
//## end Chain%4180176A01EC.postscript

// Class Chain::ChainError 

// Class Chain::ParamID 

inline int Chain::ParamID::operator==(const Chain::ParamID &right) const
{
  //## begin Chain::ParamID::operator==%41EFE7EC02EE_eq.body preserve=yes
   return modName==right.modName && parName==right.parName 
                && index==right.index && units==right.units;
  //## end Chain::ParamID::operator==%41EFE7EC02EE_eq.body
}

inline int Chain::ParamID::operator!=(const Chain::ParamID &right) const
{
  //## begin Chain::ParamID::operator!=%41EFE7EC02EE_neq.body preserve=yes
   return !(*this == right);
  //## end Chain::ParamID::operator!=%41EFE7EC02EE_neq.body
}


// Class Chain::ChainInterrupt 

// Class Chain 


//## Other Operations (inline)
inline const string& Chain::getFileName () const
{
  //## begin Chain::getFileName%4181191D03DC.body preserve=yes
  return m_fileName;
  //## end Chain::getFileName%4181191D03DC.body
}

//## Get and Set Operations for Class Attributes (inline)

inline size_t Chain::burnLength () const
{
  //## begin Chain::burnLength%4181171F0022.get preserve=no
  return m_burnLength;
  //## end Chain::burnLength%4181171F0022.get
}

inline size_t Chain::length () const
{
  //## begin Chain::length%4181174C003E.get preserve=no
  return m_length;
  //## end Chain::length%4181174C003E.get
}

inline void Chain::length (size_t value)
{
  //## begin Chain::length%4181174C003E.set preserve=no
  m_length = value;
  //## end Chain::length%4181174C003E.set
}

inline bool Chain::rand () const
{
  //## begin Chain::rand%418117CE01A2.get preserve=no
  return m_rand;
  //## end Chain::rand%418117CE01A2.get
}

inline size_t Chain::width () const
{
  //## begin Chain::width%4182AD900241.get preserve=no
  return m_width;
  //## end Chain::width%4182AD900241.get
}

inline void Chain::width (size_t value)
{
  //## begin Chain::width%4182AD900241.set preserve=no
  m_width = value;
  //## end Chain::width%4182AD900241.set
}

inline const std::vector<Chain::ParamID>& Chain::paramIDs () const
{
  //## begin Chain::paramIDs%41EE862501DE.get preserve=no
  return m_paramIDs;
  //## end Chain::paramIDs%41EE862501DE.get
}

inline void Chain::paramIDs (const std::vector<Chain::ParamID>& value)
{
  //## begin Chain::paramIDs%41EE862501DE.set preserve=no
  m_paramIDs = value;
  //## end Chain::paramIDs%41EE862501DE.set
}

inline const string& Chain::statistic () const
{
  //## begin Chain::statistic%4214D2760151.get preserve=no
  return m_statistic;
  //## end Chain::statistic%4214D2760151.get
}

inline void Chain::statistic (const string& value)
{
  //## begin Chain::statistic%4214D2760151.set preserve=no
  m_statistic = value;
  //## end Chain::statistic%4214D2760151.set
}

inline const Chain::TemperInfoContainer& Chain::tempering () const
{
  //## begin Chain::tempering%46D2FA68013F.get preserve=no
  return m_tempering;
  //## end Chain::tempering%46D2FA68013F.get
}

inline void Chain::tempering (const Chain::TemperInfoContainer& value)
{
  //## begin Chain::tempering%46D2FA68013F.set preserve=no
  m_tempering = value;
  //## end Chain::tempering%46D2FA68013F.set
}

//## begin module%4180117A019B.epilog preserve=yes
//## end module%4180117A019B.epilog


#endif
